//=============================================================================
// rocket.
//=============================================================================
class ExRocket extends Projectile;

var float MagnitudeVel,Count,SmokeRate;
var bool bRing, bHitWater, bWaterStart;
var int NumExtraRockets;
var rockettrail trail;

simulated function Destroyed()
{
	if ( Trail != None )
		Trail.Destroy();
	Super.Destroyed();
}

simulated function PostBeginPlay()
{
	Count = -0.1;
	if (Level.bHighDetailMode) SmokeRate = 0.035;
	else SmokeRate = 0.15;
}

simulated function Tick(float DeltaTime)
{
	local SpriteSmokePuff b;

	if (bHitWater)
	{
		Disable('Tick');
		Return;
	}
	Count += DeltaTime;
	if ( (Count>(SmokeRate+FRand()*(SmokeRate+NumExtraRockets*0.035))) && (Level.NetMode!=NM_DedicatedServer) ) 
	{
		b = Spawn(class'SpriteSmokePuff');
		if (b != None)
			b.RemoteRole = ROLE_None;
		Count=0.0;
	}
}
/*
simulated function Timer()
{
	local SpriteSmokePuff b;

	if ( Region.Zone.bWaterZone || (Level.NetMode == NM_DedicatedServer) )
		Return;

	if ( Level.bHighDetailMode )
	{
		if ( Level.bDropDetail || ((NumExtraRockets > 0) && (FRand() < 0.5)) )
			Spawn(class'LightSmokeTrail');
		else
			Spawn(class'UTSmokeTrail');
		SmokeRate = 152/Speed; 
	}
	else 
	{
		SmokeRate = 0.15 + FRand()*(0.01+NumExtraRockets);
		b = Spawn(class'SpriteSmokePuff');
		if ( b != None )
			b.RemoteRole = ROLE_None;
	}
	SetTimer(SmokeRate, false);
}
*/
auto state Flying
{

	simulated function ZoneChange( Zoneinfo NewZone )
	{
		local waterring w;

		if (!NewZone.bWaterZone || bHitWater) Return;

		bHitWater = True;
		if ( Level.NetMode != NM_DedicatedServer )
		{
			w = Spawn(class'WaterRing',,,,rot(16384,0,0));
			if (w!=None)
			{
				w.DrawScale = 0.2;
				w.RemoteRole = ROLE_None;
			}
			PlayAnim( 'Still', 3.0 );
		}
		Velocity=0.6*Velocity;
	}

	simulated function ProcessTouch (Actor Other, Vector HitLocation)
	{
		if ( (Other != instigator) && !Other.IsA('Projectile') ) 
			Explode(HitLocation,Normal(HitLocation-Other.Location));
	}

	function BlowUp(vector HitLocation, RingExplosion r)
	{
		if ( Level.Game != None && !Level.Game.bTeamGame ) //bigger damage radius
			HurtRadius(0.9 * Damage,240.0, 'exploded', MomentumTransfer, HitLocation );
		else
			HurtRadius(Damage,200.0, 'exploded', MomentumTransfer, HitLocation );
		MakeNoise(1.0);

		if ( r != None )
			r.PlaySound(r.ExploSound,,6);
	}

	simulated function Explode(vector HitLocation, vector HitNormal)
	{
		local XC_SpriteBallExplosion s;
		local RingExplosion3 r;

		if ( !bDeleteMe )
		{
			if ( Level.NetMode != NM_DedicatedServer )
			{
				s = spawn(class'XC_SpriteBallExplosion',,,HitLocation + HitNormal*16);
				if ( s != None )
					s.RemoteRole = ROLE_None;
				if (bRing) 
				{
					r = Spawn(class'RingExplosion3',,,HitLocation + HitNormal*16,rotator(HitNormal));
					if ( r != None )
						r.RemoteRole = ROLE_None;
				}
			}
			BlowUp(HitLocation, r);
			Destroy();
		}
	}

	simulated function BeginState()
	{
		local vector Dir;

		Dir = vector(Rotation);
		Velocity = speed * Dir;
		Acceleration = Dir * 50;
		PlaySound(SpawnSound, SLOT_None, 2.3);
		PlayAnim( 'Armed', 0.2 );
		if (Region.Zone.bWaterZone)
		{
			bHitWater = True;
			Velocity=0.6*Velocity;
		}
	}
}

defaultproperties
{
     speed=900.000000
     MaxSpeed=1600.000000
     Damage=85.000000
     MomentumTransfer=80000
     SpawnSound=Sound'UnrealShare.Eightball.Ignite'
     ImpactSound=Sound'UnrealShare.Eightball.GrenadeFloor'
     RemoteRole=ROLE_SimulatedProxy
     bNetTemporary=True
     LifeSpan=6.000000
     AnimSequence=Armed
     AmbientSound=Sound'UnrealShare.General.Brufly1'
     Skin=FireTexture'UnrealShare.Effect16.fireeffect16'
     Mesh=LodMesh'UnrealShare.RocketM'
     DrawScale=0.050000
     AmbientGlow=96
     bUnlit=True
     SoundRadius=9
     SoundVolume=255
     LightType=LT_Steady
     LightEffect=LE_NonIncidence
     LightBrightness=126
     LightHue=28
     LightSaturation=64
     LightRadius=6
     bCorona=True
     bBounce=True
}
