class XC_BabyCow expands BabyCow abstract;

function Grazing_TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, name damageType)
{
	if ( health <= 0 )
		return;
	if ( Mom != None )
		Mom.Help(self);
	Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
	if ( NextState == 'TakeHit' )
		{
		NextState = 'Attacking'; 
		NextLabel = 'Begin';
		GotoState('TakeHit'); 
		}
	else
		GotoState('Attacking');
}

function bool TestDirection(vector dir, out vector pick, bool bAlongWall);
function Grazing_PickDestination()
{
	local vector pickdir;
	local bool success;
	local float XY, dist;

	if ( Mom == None )
	{
		if ( (Baby != None) && (VSize(Baby.Location - Location) > 400) )
		{
			Destination = Baby.Location;
			return;
		}

		// don't wander too far
		if ( bStayClose )
		{
			pickDir = StartLocation - Location;
			dist = VSize(pickDir);
			if ( dist > WanderRadius )
			{
				pickdir = pickDir/dist;
				if ( TestDirection(pickdir, Destination, true) )
				{
					if (Baby != None)
						Baby.FollowMom();
					return;
				}
			}
		}

		//Favor XY alignment
		pickdir.Z = 0;
		XY = FRand();
		if (XY < 0.3)
		{
			pickdir.X = 1;
			pickdir.Y = 0;
		}
		else if (XY < 0.6)
		{
			pickdir.X = 0;
			pickdir.Y = 1;
		}
		else
		{
			pickdir.X = 2 * FRand() - 1;
			pickdir.Y = 2 * FRand() - 1;
			pickdir = Normal(pickdir);
		}

		success = TestDirection(pickdir, Destination, false);
		if (!success)
			success = TestDirection(-1 * pickdir, Destination, true);

		if (success)
		{
			if (Baby != None)
				Baby.FollowMom();
		}
		else
		{
			Destination = Location;
			GotoState('Grazing', 'Turn');
		}
		Goto NoCraps;
	}
	if ( Mom != None && !LineOfSightTo(mom) )
	{
		MoveTarget = FindPathToward(mom);
		if ( MoveTarget != None )
		{
			Destination = MoveTarget.Location;
			return;
		}
	}
	if ( Mom != None )
	{
		if ( ScaryGuy != None )
			Destination = mom.Destination - 2 * mom.CollisionRadius * Normal(ScaryGuy.Location - mom.Destination);
		else
			Destination = mom.Destination;
	}
NoCraps:
}

function Grazing_EndState()
{
	if ( Enemy != None && Enemy.PlayerReplicationInfo != None )
		MakeNoise(1.0);
	JumpZ = Default.JumpZ;
	bAvoidLedges = false;
	MinHitWall = Default.MinHitWall;
}