class XC_ScriptedPawn expands ScriptedPawn abstract;

native(3540) final iterator function PawnActors( class<Pawn> PawnClass, out pawn P,
optional float Distance, optional vector VOrigin, optional bool bHasPRI);

native(3541) final iterator function NavigationActors( class<NavigationPoint> NavClass, out NavigationPoint P,
optional float Distance, optional vector VOrigin, optional bool bVisible);

function float Tw_RelativeStrength(Pawn Other)
{
	local float compare;
	local int adjustedStrength, adjustedOther;
	local int bTemp;

	if ( Other == None || Other.bDeleteMe || Other == Self ) return 1; //Complete null shite here
	adjustedStrength = health;
	adjustedOther = 0.5 * (Other.health + Other.Default.Health);
	compare = 0.01 * float(adjustedOther - adjustedStrength);
	if ( Intelligence == BRAINS_Human )
	{
		if ( Weapon != None )
		{
			compare -= (Weapon.RateSelf(bTemp) - 0.3);
			if ( bIsPlayer && (Weapon.AIRating < 0.3) ) //LOL >> till have a weapon...
			{
				compare += 0.2;
				if ( (Other.Weapon != None) && (Other.Weapon.AIRating >= 0.3) )
					compare += 0.3;
			}
		}
		if ( Other.Weapon != None )
			compare += (Other.Weapon.RateSelf(bTemp) - 0.3);
	}
	//log(other.class$" relative strength to "$class$" is "$compare);
	return compare;
}

function StakeOut_BeginState()
{
	if ( Enemy != None && !Enemy.bDeleteMe && Enemy != Self )
	{
		Acceleration = vect(0,0,0);
		bCanJump = false;
		bClearShot = true;
		bReadyToAttack = true;
		SetAlertness(0.5);
	}
	else
		WhatToDoNext('','');
}

function bool Tw_MeleeDamageTarget(int hitdamage, vector pushdir)
{
	local vector HitLocation, HitNormal, TargetPoint;
	local actor HitActor;

	if ( Target == None && ( Enemy != None && Enemy.Health > 0 && Enemy != Self ) )
		Target = Enemy;
	if ( Target != None && Target != Self )
	{
		if ( (VSize(Target.Location - Location) <= MeleeRange * 1.4 + Target.CollisionRadius + CollisionRadius)
			&& ((Physics == PHYS_Flying) || (Physics == PHYS_Swimming) || (Abs(Location.Z - Target.Location.Z) 
				<= FMax(CollisionHeight, Target.CollisionHeight) + 0.5 * FMin(CollisionHeight, Target.CollisionHeight))) )
		{
			HitActor = Trace(HitLocation, HitNormal, Target.Location, Location, false);
			if ( HitActor != None )
				return false;
			Target.TakeDamage(hitdamage, Self,HitLocation, pushdir, 'hacked');
			return true;
		}
	}
	return false;
}

function Tw_StartRoaming()
{
	local float oldestRoamTime;
	local ScriptedPawn oldestRoamer, SP;
	local int numRoamers;

	RoamStartTime = Level.TimeSeconds;
	oldestRoamTime = RoamStartTime;

	ForEach PawnActors( class'ScriptedPawn', SP)
		if ( !SP.bIsPlayer && (SP.IsInState('Roaming') || SP.IsInState('Wandering')) )
		{
			numRoamers++;
			if ( (SP.RoamStartTime < oldestRoamTime) || (oldestRoamer == None) )
			{
				oldestRoamer = SP;
				oldestRoamTime = SP.RoamStartTime;
			}
		}

	if ( numRoamers > 100 )
		oldestRoamer.GotoState('Waiting', 'TurnFromWall');
	OrderObject = None;
	OrderTag = '';
	GotoState('Roaming');
}

function Patroling_TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
					Vector momentum, name damageType)
{
	Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
	if ( health <= 0 )
		return;
	if ( instigatedBy != None && instigatedBy.Health > 0 && instigatedBy != Self )
		Enemy = instigatedBy;
	else
		Goto NothingSpecial;
	if ( Enemy != None )
		LastSeenPos = Enemy.Location;
	if ( NextState == 'TakeHit' )
	{
		NextState = 'Attacking'; 
		NextLabel = 'Begin';
		GotoState('TakeHit'); 
	}
	else if ( Enemy != None )
		GotoState('Attacking');
NothingSpecial:
}

function Guarding_TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, name damageType)
{
	Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
	if ( health <= 0 )
		return;
	if ( instigatedBy != None && instigatedBy.Health > 0 && instigatedBy != Self )
		Enemy = instigatedBy;
	else
		Goto NothingSpecial;
	if ( Enemy != None )
		LastSeenPos = Enemy.Location;
	if (NextState == 'TakeHit')
	{
		NextState = 'Attacking'; 
		NextLabel = 'Begin';
		GotoState('TakeHit'); 
	}
	else if ( Enemy != None )
		GotoState('Attacking');
NothingSpecial:
}

function Acquisition_TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, name damageType)
{
	Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
	if ( health <= 0 )
		return;
	if ( instigatedBy != None && instigatedBy.Health > 0 && instigatedBy != Self )
		Enemy = instigatedBy;
	else
		Goto NothingSpecial;
	if ( Enemy != None )
		LastSeenPos = Enemy.Location;
	if (NextState == 'TakeHit')
	{
		NextState = 'Attacking'; 
		NextLabel = 'Begin';
		GotoState('TakeHit'); 
	}
	else if ( Enemy != None )
		GotoState('Attacking');
NothingSpecial:
}

function Threatening_TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, name damageType)
{
	Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
	if ( health <= 0 )
		return;
	if ( instigatedBy != None && instigatedBy.Health > 0 && instigatedBy != Self )
		Enemy = instigatedBy;
	else
		Goto NothingSpecial;
	if ( Enemy != None )
		LastSeenPos = Enemy.Location;
	if (NextState == 'TakeHit')
	{
		bReadyToAttack = true;
		NextState = 'Attacking'; 
		NextLabel = 'Begin';
		GotoState('TakeHit'); 
	}
	else
	{
		bReadyToAttack = true;
		GotoState('Attacking');
	}
NothingSpecial:
}

function Charging_Timer()
{
	if ( Enemy != None && Enemy.Health > 0 && Enemy != Self )
	{
		bReadyToAttack = True;
		Target = Enemy;
		if (VSize(Enemy.Location - Location) 
				<= (MeleeRange + Enemy.CollisionRadius + CollisionRadius))
			GotoState('MeleeAttack');
		else if ( bHasRangedAttack && (FRand() > 0.7 + 0.1 * skill) ) 
			GotoState('RangedAttack');
		else if ( bHasRangedAttack && !bMovingRangedAttack)
		{ 
			if ( FRand() < CombatStyle * 0.8 ) //then keep charging
				SetTimer(1.0,false); 
			else
				GotoState('Attacking');
		}
	}
	else
	{
		WhatToDoNext('','');
	}
}

function TacticalMove_Timer()
{
	if ( Enemy != None && Enemy.Health > 0 && Enemy != Self )
	{
		bReadyToAttack = True;
		Enable('Bump');
		Target = Enemy;
		if (VSize(Enemy.Location - Location) 
				<= (MeleeRange + Enemy.CollisionRadius + CollisionRadius))
			GotoState('MeleeAttack');
		else if ( bHasRangedAttack && ((!bMovingRangedAttack && (FRand() < 0.8)) || (FRand() > 0.5 + 0.17 * skill)) ) 
			GotoState('RangedAttack');
	}
	else
	{
		WhatToDoNext('','');
	}
}

	function GiveUpTactical(bool bNoCharge);
	function TacticalMove_PickDestination(bool bNoCharge)
	{
		local vector pickdir, enemydir, enemyPart, Y, minDest;
		local actor HitActor;
		local vector HitLocation, HitNormal, collSpec;
		local float Aggression, enemydist, minDist, strafeSize, optDist;
		local bool success, bNoReach;

		if ( Enemy == None || Enemy.Health < 0 || Enemy == Self )
		{
			Destination = Focus;
			WhatToDoNext('','');
			Goto LOLz;
		}
		bChangeDir = false;
		if (Region.Zone.bWaterZone && !bCanSwim && bCanFly)
		{
			Destination = Location + 75 * (VRand() + vect(0,0,1));
			Destination.Z += 100;
			return;
		}
		if ( Enemy.Region.Zone.bWaterZone )
			bNoCharge = bNoCharge || !bCanSwim;
		else 
			bNoCharge = bNoCharge || (!bCanFly && !bCanWalk);

		success = false;
		enemyDist = VSize(Location - Enemy.Location);
		Aggression = 2 * (CombatStyle + FRand()) - 1.1;
		if ( intelligence == BRAINS_Human )
		{
			if ( Enemy.bIsPlayer && (AttitudeToPlayer == ATTITUDE_Fear) && (CombatStyle > 0) )
				Aggression = Aggression - 2 - 2 * CombatStyle;
			if ( Weapon != None )
				Aggression += 2 * Weapon.SuggestAttackStyle();
			if ( Enemy.Weapon != None )
				Aggression += 2 * Enemy.Weapon.SuggestDefenseStyle();
		}

		if ( enemyDist > 1000 )
			Aggression += 1;
		if ( bIsPlayer && !bNoCharge )
			bNoCharge = ( Aggression < FRand() );

		if ( (Physics == PHYS_Walking) || (Physics == PHYS_Falling) )
		{
			if (Location.Z > Enemy.Location.Z + 140) //tactical height advantage
				Aggression = FMax(0.0, Aggression - 1.0 + CombatStyle);
			else if (Location.Z < Enemy.Location.Z - CollisionHeight) // below enemy
			{
				if ( !bNoCharge && (Intelligence > BRAINS_Reptile) 
					&& (Aggression > 0) && (FRand() < 0.6) )
				{
					GotoState('Charging');
					return;
				}
				else if ( (enemyDist < 1.1 * (Enemy.Location.Z - Location.Z)) 
						&& !actorReachable(Enemy) ) 
				{
					bNoReach = (Intelligence > BRAINS_None);
					aggression = -1.5 * FRand();
				}
			}
		}

		if (!bNoCharge && (Aggression > 2 * FRand()))
		{
			if ( bNoReach && (Physics != PHYS_Falling) )
			{
				TweenToRunning(0.15);
				GotoState('Charging', 'NoReach');
			}
			else
				GotoState('Charging');
			return;
		}

		if (enemyDist > FMax(VSize(OldLocation - Enemy.OldLocation), 240))
			Aggression += 0.4 * FRand();

		enemydir = (Enemy.Location - Location)/enemyDist;
		minDist = FMin(160.0, 3*CollisionRadius);
		if ( bIsPlayer )
			optDist = 80 + FMin(EnemyDist, 250 * (FRand() + FRand()));  
		else 
			optDist = 50 + FMin(EnemyDist, 500 * FRand());
		Y = (enemydir Cross vect(0,0,1));
		if ( Physics == PHYS_Walking )
		{
			Y.Z = 0;
			enemydir.Z = 0;
		}
		else 
			enemydir.Z = FMax(0,enemydir.Z);

		strafeSize = FMax(-0.7, FMin(0.85, (2 * Aggression * FRand() - 0.3)));
		enemyPart = enemydir * strafeSize;
		strafeSize = FMax(0.0, 1 - Abs(strafeSize));
		pickdir = strafeSize * Y;
		if ( bStrafeDir )
			pickdir *= -1;
		bStrafeDir = !bStrafeDir;
		collSpec.X = CollisionRadius;
		collSpec.Y = CollisionRadius;
		collSpec.Z = FMax(6, CollisionHeight - 18);

		minDest = Location + minDist * (pickdir + enemyPart);
		HitActor = Trace(HitLocation, HitNormal, minDest, Location, false, collSpec);
		if (HitActor == None)
		{
			success = (Physics != PHYS_Walking);
			if ( !success )
			{
				collSpec.X = FMin(14, 0.5 * CollisionRadius);
				collSpec.Y = collSpec.X;
				HitActor = Trace(HitLocation, HitNormal, minDest - (18 + MaxStepHeight) * vect(0,0,1), minDest, false, collSpec);
				success = (HitActor != None);
			}
			if (success)
				Destination = minDest + (pickdir + enemyPart) * optDist;
		}

		if ( !success )
		{
			collSpec.X = CollisionRadius;
			collSpec.Y = CollisionRadius;
			minDest = Location + minDist * (enemyPart - pickdir); 
			HitActor = Trace(HitLocation, HitNormal, minDest, Location, false, collSpec);
			if (HitActor == None)
			{
				success = (Physics != PHYS_Walking);
				if ( !success )
				{
					collSpec.X = FMin(14, 0.5 * CollisionRadius);
					collSpec.Y = collSpec.X;
					HitActor = Trace(HitLocation, HitNormal, minDest - (18 + MaxStepHeight) * vect(0,0,1), minDest, false, collSpec);
					success = (HitActor != None);
				}
				if (success)
					Destination = minDest + (enemyPart - pickdir) * optDist;
			}
			else 
			{
				if ( (CombatStyle <= 0) || (Enemy.bIsPlayer && (AttitudeToPlayer == ATTITUDE_Fear)) )
					enemypart = vect(0,0,0);
				else if ( (enemydir Dot enemyPart) < 0 )
					enemyPart = -1 * enemyPart;
				pickDir = Normal(enemyPart - pickdir + HitNormal);
				minDest = Location + minDist * pickDir;
				collSpec.X = CollisionRadius;
				collSpec.Y = CollisionRadius;
				HitActor = Trace(HitLocation, HitNormal, minDest, Location, false, collSpec);
				if (HitActor == None)
				{
					success = (Physics != PHYS_Walking);
					if ( !success )
					{
						collSpec.X = FMin(14, 0.5 * CollisionRadius);
						collSpec.Y = collSpec.X;
						HitActor = Trace(HitLocation, HitNormal, minDest - (18 + MaxStepHeight) * vect(0,0,1), minDest, false, collSpec);
						success = (HitActor != None);
					}
					if (success)
						Destination = minDest + pickDir * optDist;
				}
			}
		}

		if ( !success )
			GiveUpTactical(bNoCharge);
		else 
		{
			pickDir = (Destination - Location);
			enemyDist = VSize(pickDir);
			if ( enemyDist > minDist + 2 * CollisionRadius )
			{
				pickDir = pickDir/enemyDist;
				HitActor = Trace(HitLocation, HitNormal, Destination + 2 * CollisionRadius * pickdir, Location, false);
				if ( (HitActor != None) && ((HitNormal Dot pickDir) < -0.6) )
					Destination = HitLocation - 2 * CollisionRadius * pickdir;
			}
		}
	LOLz:
	}


function XC_PlayCombatMove()
{
	if ( Enemy != None && Enemy.Health > 0 && Enemy != Self )
	{
		if ( bMovingRangedAttack && bReadyToAttack && bCanFire && !NeedToTurn(Enemy.Location) )
		{
			Target = Enemy;
			PlayMovingAttack();
			if ( FRand() > 0.5 * (0.5 + skill * 0.25 + ReFireRate) )
			{
				bReadyToAttack = false;
				SetTimer(TimeBetweenAttacks  * (1.0 + FRand()),false); 
			}
		}
		else 
		{
			if ( !bReadyToAttack && (TimerRate == 0.0) )
				SetTimer(0.7, false);
			PlayRunning();
		}
	}
	else
	{
		WhatToDoNext('','');
		GoTo NothingToMessWith;
	}
NothingToMessWith:
}

function TacticalMove_BeginState()
{
	if ( Enemy == None || Enemy.Health < 0 || Enemy == Self )
	{
		WhatToDoNext('','');
		Goto NoTactical;
	}
	MinHitWall += 0.15;
	bAvoidLedges = ( !bCanJump && (CollisionRadius > 40) );
	bCanJump = false;
	bCanFire = false;
NoTactical:
}

function Killed(pawn Killer, pawn Other, name damageType)
{
	local Pawn aPawn;
	local ScriptedPawn ScriptedOther;
	local bool bFoundTeam;

	if ( Health <= 0 )
		return;
	if (Other.bIsPlayer)
		bCanBePissed = true;

	ScriptedOther = ScriptedPawn(Other);
	if ( (TeamTag != '') && (ScriptedOther != None) 
		&& (ScriptedOther.TeamTag == TeamTag) )
	{
		if ( ScriptedOther.bTeamLeader )
			TeamTag = '';
		else if ( ScriptedOther.TeamID < TeamID )
			TeamID--;
		else if ( bTeamLeader )
		{
			aPawn = Level.PawnList;
			while ( aPawn != None )
			{
				if ( (ScriptedPawn(aPawn) != None) && (ScriptedPawn(aPawn) != self) &&
					(ScriptedPawn(aPawn).TeamTag == TeamTag) )
				{
					bFoundTeam = true;
					break;
				}
				aPawn = aPawn.nextPawn;
			}
			if ( !bFoundTeam )
			{
				bTeamLeader = false;
				TeamTag = '';
			}
		}
	}

	if ( OldEnemy == Other )
		OldEnemy = None;

	if ( Enemy == Other )
	{
		Enemy = None;
		if ( (Killer == self) && (OldEnemy == None) )
		{
			ForEach PawnActors( class'Pawn', aPawn )
			{
				if ( !aPawn.bHidden && aPawn.Mesh != None && aPawn.DrawType == DT_Mesh
					&& aPawn.bCollideActors && aPawn != Self
					&& (VSize(Location - aPawn.Location) < 1500)
					&& LineOfSightTo(aPawn) )
				{
					if ( SetEnemy(aPawn) )
					{
						GotoState('Attacking');
						return;
					}
				}
			}
		}
		WhatToDoNext('','');
	}
NoFurtherAction:
}

function StartUp_SetHome()
{
	local HomeBase aHome;

	ForEach NavigationActors( class'HomeBase', aHome)
		if ( aHome.Tag == Tag )
		{
			home = aHome;
			return;
		}
}
/*
function ChooseAttackMode()
{
	local eAttitude AttitudeToEnemy;
	local float Aggression;
	local pawn changeEn;

	log (Self.Name@"enemy is"@Enemy);
	if ( Enemy == None || Enemy.Health <= 0 )
	{
		if ( Orders == 'Attacking' )
			Orders = '';
		WhatToDoNext('','');
		return;
	}

	if ( (AlarmTag != '') && Enemy.bIsPlayer )
	{
		if (AttitudeToPlayer > ATTITUDE_Ignore)
		{
			GotoState('AlarmPaused', 'WaitForPlayer');
			return;
		}
		else if ( (AttitudeToPlayer != ATTITUDE_Fear) || bInitialFear )
		{
			GotoState('TriggerAlarm');
			return;
		}
	}

	AttitudeToEnemy = AttitudeTo(Enemy);

	if (AttitudeToEnemy == ATTITUDE_Fear)
	{
		GotoState('Retreating');
		return;
	}

	else if (AttitudeToEnemy == ATTITUDE_Threaten)
	{
		GotoState('Threatening');
		return;
	}

	else if (AttitudeToEnemy == ATTITUDE_Friendly)
	{
		if ( Enemy.bIsPlayer )
			GotoState('Greeting');
		else
			WhatToDoNext('','');
		return;
	}

	else if ( !LineOfSightTo(Enemy) )
	{
		if ( (OldEnemy != None) 
			&& (AttitudeTo(OldEnemy) == ATTITUDE_Hate) && LineOfSightTo(OldEnemy) )
		{
			changeEn = enemy;
			enemy = oldenemy;
			oldenemy = changeEn;
		}
		else 
		{
			if ( (Orders == 'Guarding') && !LineOfSightTo(OrderObject) )
				GotoState('Guarding');
			else if ( !bHasRangedAttack || VSize(Enemy.Location - Location) 
						> 600 + (FRand() * RelativeStrength(Enemy) - CombatStyle) * 600 )
				GotoState('Hunting');
			else if ( bIsBoss || (Intelligence > BRAINS_None) )
			{
				HuntStartTime = Level.TimeSeconds;
				NumHuntPaths = 0; 
				GotoState('StakeOut');
			}
			else
				WhatToDoNext('Waiting', 'TurnFromWall');
			return;
		}
	}

	else if ( (TeamLeader != None) && TeamLeader.ChooseTeamAttackFor(self) )
		return;

	if (bReadyToAttack)
	{
		////log("Attack!");
		Target = Enemy;
		If (VSize(Enemy.Location - Location) <= (MeleeRange + Enemy.CollisionRadius + CollisionRadius))
		{
			GotoState('MeleeAttack');
			return;
		}
		else if (bMovingRangedAttack)
			SetTimer(TimeBetweenAttacks, False);
		else if (bHasRangedAttack && ( Enemy.bIsPlayer) && CanFireAtEnemy() )
		{
			if (!bIsPlayer || (2.5 * FRand() > Skill) )
			{
				GotoState('RangedAttack');
				return;
			}
		}
	}
}
*/

function bool ChooseTeamAttackFor(ScriptedPawn TeamMember)
{
	if ( ( Enemy == None ) && TeamMember != None && TeamMember.Enemy != None && LineOfSightTo(TeamMember) )
	{
		if (SetEnemy(TeamMember.Enemy))
			MakeNoise(1.0);
	}
	if ( TeamMember == None || (TeamMember != None && !LineOfSightTo(TeamMember)) || ( TeamMember != None && TeamMember.Enemy != None && !LineOfSightTo(TeamMember.Enemy) ) || Health < 1 )
		return false;

	// speak order
	if ( !bTeamSpeaking )
		SpeakOrderTo(TeamMember);

	// set CombatStyle and Aggressiveness of TeamMember
	if ( TeamMember == Self )
	{
		ChooseLeaderAttack();
		return true;
	}

	if ( TeamMember != None && TeamMember.bReadyToAttack && TeamMember.Enemy != None )
	{
		////log("Attack!");
		TeamMember.Target = TeamMember.Enemy;
		if ( Enemy != None && Enemy.Health > 0 && Enemy != Self )
		If (VSize(Enemy.Location - Location) <= (TeamMember.MeleeRange + TeamMember.Enemy.CollisionRadius + TeamMember.CollisionRadius))
		{
			TeamMember.GotoState('MeleeAttack');
			return true;
		}
		else if (TeamMember.bMovingRangedAttack || (TeamMember.TeamID == 1) )
			TeamMember.SetTimer(TimeBetweenAttacks, False);
		else if (TeamMember.bHasRangedAttack && (TeamMember.bIsPlayer || TeamMember.Enemy.bIsPlayer) && TeamMember.CanFireAtEnemy() )
		{
			if ( !TeamMember.bIsPlayer || (3 * FRand() > Skill) )
			{
				TeamMember.GotoState('RangedAttack');
				return true;
			}
		}
	}

	if ( !TeamMember.bHasRangedAttack || (TeamMember.TeamID == 1) )
		TeamMember.GotoState('Charging');
	else if ( TeamMember.TeamID == 2 )
	{
		TeamMember.bStrafeDir = true;
		TeamMember.GotoState('TacticalMove', 'NoCharge'); 
	}
	else if ( TeamMember.TeamID == 3 )
	{
		TeamMember.bStrafeDir = false;
		TeamMember.GotoState('TacticalMove', 'NoCharge'); 
	}
	else
		TeamMember.GotoState('TacticalMove');

	return true;
}

function eAttitude AttitudeTo(Pawn Other)
{
	if ( Other.bDeleteMe || Other == None || Other.Health < 0
	|| Other.bHidden || Other.Mesh == None || Other.DrawType != DT_Mesh || !Other.bCollideActors )
		return ATTITUDE_Ignore;
	if ( Other.PlayerReplicationInfo != None ) //Replaced shit line
	{
//Pretty Useless
		if ( Level.Game.IsA('TeamGame') && (Team == Other.PlayerReplicationInfo.Team) )
			return ATTITUDE_Friendly;

		else if ( (Intelligence > BRAINS_None) && 
			((AttitudeToPlayer == ATTITUDE_Hate) || (AttitudeToPlayer == ATTITUDE_Threaten) 
				|| (AttitudeToPlayer == ATTITUDE_Fear)) ) //check if afraid 
		{
			if (RelativeStrength(Other) > Aggressiveness)
				AttitudeToPlayer = AttitudeWithFear();
			else if (AttitudeToPlayer == ATTITUDE_Fear)
				AttitudeToPlayer = ATTITUDE_Hate;
		}
		return AttitudeToPlayer;
	}
	else if (Hated == Other)
	{
		if (RelativeStrength(Other) >= Aggressiveness)
			return AttitudeWithFear();
		else 
			return ATTITUDE_Hate;
	}
	else if ( (TeamTag != '') && (ScriptedPawn(Other) != None) && (TeamTag == ScriptedPawn(Other).TeamTag) || ( ScriptedPawn(Other) != None && Level.Game.IsA('MonsterHunt') ) )
		return ATTITUDE_Friendly;
	else
		return AttitudeToCreature(Other); 
}

function SeePlayer(Actor SeenPlayer)
{
	local Actor A;
	local vector HitLocation, HitNormal;

	A = TraceShot( HitLocation, HitNormal, SeenPlayer.Location, Location );
	if ( A != None && A == SeenPlayer )
		if ( !SeenPlayer.bHidden && SeenPlayer.bCollideActors && SeenPlayer.Mesh != None && SeenPlayer.DrawType == DT_Mesh )
			if ( SetEnemy(Pawn(SeenPlayer)) )
				LastSeenPos = Enemy.Location;
}

final function Tw_FireProjectile(vector StartOffset, float Accuracy)
{
	local vector X,Y,Z, projStart;

	MakeNoise(1.0);
	GetAxes(Rotation,X,Y,Z);
	projStart = Location + StartOffset.X * CollisionRadius * X 
					+ StartOffset.Y * CollisionRadius * Y 
					+ StartOffset.Z * CollisionRadius * Z;
	if ( Caps(String(RangedProjectile))== "UNREALI.WARLORDROCKET")
	{
		spawn(Class 'ExWarlordRocket' ,self,'',projStart,AdjustAim(ProjectileSpeed, projStart, Accuracy, bLeadTarget, bWarnTarget));
	}
	else
		spawn(RangedProjectile ,self,'',projStart,AdjustAim(ProjectileSpeed, projStart, Accuracy, bLeadTarget, bWarnTarget));
}

function rotator Tw_AdjustAim(float projSpeed, vector projStart, int aimerror, bool leadTarget, bool warnTarget)
{
	local rotator FireRotation;
	local vector FireSpot;
	local actor HitActor;
	local vector HitLocation, HitNormal;

	if ( Target == None )
		FireSpot = Focus;
	else
		FireSpot = LastSeenPos;
	aimerror = aimerror * (0.5 * (4 - skill - FRand()));
 
	HitActor = Trace(HitLocation, HitNormal, FireSpot, ProjStart, false);
	if( HitActor != None ) 
	{
		////log("adjust aim up");
		if ( Target != None && !Target.bDeleteMe )
			FireSpot.Z += 0.9 * Target.CollisionHeight;
		HitActor = Trace(HitLocation, HitNormal, FireSpot, ProjStart, false);
		bClearShot = (HitActor == None);
	}
	FireRotation = Rotator(FireSpot - ProjStart);
	FireRotation.Yaw = FireRotation.Yaw + 0.5 * (Rand(2 * aimerror) - aimerror);
	viewRotation = FireRotation;
	return FireRotation;
}