class XC_SkaarjTrooper expands SkaarjTrooper abstract;

native(3552) final iterator function CollidingActors( class<actor> BaseClass, out actor Actor, float Radius, optional vector Loc);
native(3541) final iterator function NavigationActors( class<NavigationPoint> NavClass, out NavigationPoint P,
optional float Distance, optional vector VOrigin, optional bool bVisible);

function StartUp_BeginState()
{
	local Weapon W;

	SetMovementPhysics(); 
	if (Physics == PHYS_Walking)
		SetPhysics(PHYS_Falling);
	if ( WeaponType != None )
		myWeapon = Spawn(WeaponType);
	else
	{
		if (Class.Default.WeaponType != None)
			WeaponType = class.default.WeaponType;
		else
			{
				foreach AllActors (class'Weapon',W)
				{
					WeaponType = W.class;
					Break;
				}
			}
		if ( WeaponType != None )
			myWeapon = Spawn(WeaponType);
		else
		{
			WeaponType = Class 'ASMD';
			myWeapon = Spawn(WeaponType);
		}
	}
	if ( myWeapon != None )
	{
		myWeapon.ReSpawnTime=0.0;
		myWeapon.bWeaponStay=False;
	}
}

function St_SetHome()
{
	local Weapon W;
	local HomeBase aHome;

	if ( myWeapon != None )
	{
		myWeapon.BecomeItem(); //Do not mess anims
		myWeapon.Instigator = Self;
		AddInventory(myWeapon);
		myWeapon.GiveAmmo(Self);
		myWeapon.WeaponSet(Self);
		Weapon=MyWeapon;
	}
	if ( Weapon == None )
	{
		foreach CollidingActors(class'Weapon',W,CollisionRadius-1,Location )
		{
			if ( W.MyMarker == None )
			{
				W.ReSpawnTime=0.0;
				W.BecomeItem();
				W.Instigator = Self;
				AddInventory(W);
				W.GiveAmmo(Self);
				W.WeaponSet(Self);
				Weapon=W;
				break;
			}
		}
	}

	ForEach NavigationActors( class'HomeBase', aHome)
	if ( aHome.Tag == Tag )
	{
		home = aHome;
		return;
	}
}

function Tw_PlayMovingAttack()
{
	local float strafeMag;
	local vector Focus2D, Loc2D, Dest2D;
	local vector lookDir, moveDir, Y;
	local int bUseAltMode;

	if ( Weapon != None )
	{
		if ( Weapon.AmmoType != None )
			Weapon.AmmoType.AmmoAmount = Weapon.AmmoType.Default.AmmoAmount+2;
		Weapon.RateSelf(bUseAltMode);
		ViewRotation = Rotation;
		if ( bUseAltMode == 0 ) 
		{
			bFire = 1;
			bAltFire = 0;
			Weapon.Fire(1.0);
		}
		else
		{
			bFire = 0;
			bAltFire = 1;
			Weapon.AltFire(1.0);
		}
	}
	else
	{
		PlayRunning();
		GoTo NothingBellow;
	}

	if (Region.Zone.bWaterZone)
	{
		PlaySwimming();
		GoTo NothingBellow;
	}

	DesiredSpeed = MaxDesiredSpeed;

	if (Focus == Destination)
	{
		LoopAnim('JogFire', -0.9/GroundSpeed,, 0.4);
		GoTo NothingBellow;
	}
	Focus2D = Focus;
	Focus2D.Z = 0;
	Loc2D = Location;
	Loc2D.Z = 0;
	Dest2D = Destination;
	Dest2D.Z = 0;
	lookDir = Normal(Focus2D - Loc2D);
	moveDir = Normal(Dest2D - Loc2D);
	strafeMag = lookDir dot moveDir;
	if (strafeMag > 0.8)
		LoopAnim('JogFire', -1.0/GroundSpeed,, 0.4);
	else if (strafeMag < -0.8)
		LoopAnim('JogFire', -1.0/GroundSpeed,, 0.4);
	else
	{
		MoveTimer += 0.2;
		DesiredSpeed = 0.6;
		Y = (lookDir Cross vect(0,0,1));
		if ((Y Dot (Dest2D - Loc2D)) > 0) 
		{
			if ( (AnimSequence == 'StrafeRight') || (AnimSequence == 'StrafeRightFr') ) 
				LoopAnim('StrafeRightFr', -2.5/GroundSpeed,, 1.0); 
			else
				LoopAnim('StrafeRightFr', -2.5/GroundSpeed,0.1, 1.0); 
		}
		else
		{
			if ( (AnimSequence == 'StrafeLeft') || (AnimSequence == 'StrafeLeftFr') ) 
				LoopAnim('StrafeLeftFr', -2.5/GroundSpeed,, 1.0);
			else
				LoopAnim('StrafeLeftFr', -2.5/GroundSpeed,0.1, 1.0);
		}
	}
NothingBellow:
}

function Tw_PlayFiring()
{
	TweenAnim('Firing', 0.2);
	if ( Weapon != None && Weapon.AmmoType != None )
		Weapon.AmmoType.AmmoAmount = Weapon.AmmoType.Default.AmmoAmount+2;
}
